/******************************************************
*vAudio ver 3.0.2 Ŏgpł֐̒`t@CB    *
*													  *
*									   by HolyWings	  *
*******************************************************/

#ifndef INCLUDE_VAUDIO_H
#define INCLUDE_VAUDIO_H

#include <windows.h>

#ifdef _MSC_VER
#ifdef MAKE_DLL

#define VAUDIO_API	__declspec( dllexport ) 

#else

#define VAUDIO_API  __declspec( dllimport )

#endif
#else

#define VAUDIO_API

#endif

/***************************************
*vAudioŋN肤G[@@@@@@@*
****************************************/
#define VAUDIO_ERR_NONE					0
#define VAUDIO_ERR_DONOT_INIT			1
#define VAUDIO_ERR_UNSUPPORTED_DATA		2
#define VAUDIO_ERR_INVALID_PARAM		3
#define VAUDIO_ERR_INVALID_AUDIOHANDLE 	4
#define VAUDIO_ERR_UNKNOWN_FILE			5
#define VAUDIO_ERR_INVALID_CALL			6
#define VAUDIO_ERR_INTERNAL_DX			7
#define VAUDIO_ERR_INTERNAL_SYSTEM		8
#define VAUDIO_ERR_INVALID_EFFECT_PARAM 9


/*********************************
*vAudioňt@C̎    *
**********************************/ 

#define VAUDIO_FILETYPE_WAVE		0
#define VAUDIO_FILETYPE_MP3			1
#define VAUDIO_FILETYPE_OGG			2
#define VAUDIO_FILETYPE_FLAC		3
#define VAUDIO_FILETYPE_MIDI		4

/****************************************/
/*vAudioŎgpvC[̃^Cv*/
/****************************************/
#define VAUDIO_PLAYERTYPE_AUTO			0
#define VAUDIO_PLAYERTYPE_NORMAL		1
#define VAUDIO_PLAYERTYPE_STREAMING		2

/*************************************
*vAudioŎgpłGtFNg        *
**************************************/

/*R[X*/
#define VAUDIO_EFFECT_CHORUS		1
/*RvbT[*/
#define VAUDIO_EFFECT_COMPRESSOR	2
/*fBXg[V*/
#define VAUDIO_EFFECT_DISTORTION	4
/*GR[ */
#define VAUDIO_EFFECT_ECHO			8
/*tW*/
#define VAUDIO_EFFECT_FLANGER		16
/*K[O*/
#define VAUDIO_EFFECT_GARGLE		32
/*o[u*/
#define VAUDIO_EFFECT_REVERB		64
/*pgbNCRCU*/
#define VAUDIO_EFFECT_PARAMEQ		128
/*I3DL2 (Interactive 3D Audio Level 2) o[u */
#define VAUDIO_EFFECT_I3DL2REVERB	256

/*R[XGtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_CHORUS_PARAM
{
	float       fWetDryMix;
    float       fDepth;
    float       fFeedback;
    float       fFrequency;
    long        lWaveform;
    float       fDelay;
    long        lPhase;

}VAUDIO_CHORUS_PARAM;

#define VAUDIO_CHORUS_WAVE_TRIANGLE        0
#define VAUDIO_CHORUS_WAVE_SIN             1

#define VAUDIO_CHORUS_WETDRYMIX_MIN        0.0f
#define VAUDIO_CHORUS_WETDRYMIX_MAX        100.0f
#define VAUDIO_CHORUS_DEPTH_MIN            0.0f
#define VAUDIO_CHORUS_DEPTH_MAX            100.0f
#define VAUDIO_CHORUS_FEEDBACK_MIN         -99.0f
#define VAUDIO_CHORUS_FEEDBACK_MAX         99.0f
#define VAUDIO_CHORUS_FREQUENCY_MIN        0.0f
#define VAUDIO_CHORUS_FREQUENCY_MAX        10.0f
#define VAUDIO_CHORUS_DELAY_MIN            0.0f
#define VAUDIO_CHORUS_DELAY_MAX            20.0f
#define VAUDIO_CHORUS_PHASE_MIN            0
#define VAUDIO_CHORUS_PHASE_MAX            4

#define VAUDIO_CHORUS_PHASE_NEG_180        0
#define VAUDIO_CHORUS_PHASE_NEG_90         1
#define VAUDIO_CHORUS_PHASE_ZERO           2
#define VAUDIO_CHORUS_PHASE_90             3
#define VAUDIO_CHORUS_PHASE_180            4

/*RvbT[GtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_COMPRESSOR_PARAM
{
    float   fGain;
    float   fAttack;
    float   fRelease;
    float   fThreshold;
    float   fRatio;
    float   fPredelay;
	
}VAUDIO_COMPRESSOR_PARAM;

#define VAUDIO_COMPRESSOR_GAIN_MIN             -60.0f
#define VAUDIO_COMPRESSOR_GAIN_MAX             60.0f
#define VAUDIO_COMPRESSOR_ATTACK_MIN           0.01f
#define VAUDIO_COMPRESSOR_ATTACK_MAX           500.0f
#define VAUDIO_COMPRESSOR_RELEASE_MIN          50.0f
#define VAUDIO_COMPRESSOR_RELEASE_MAX          3000.0f
#define VAUDIO_COMPRESSOR_THRESHOLD_MIN        -60.0f
#define VAUDIO_COMPRESSOR_THRESHOLD_MAX        0.0f
#define VAUDIO_COMPRESSOR_RATIO_MIN            1.0f
#define VAUDIO_COMPRESSOR_RATIO_MAX            100.0f
#define VAUDIO_COMPRESSOR_PREDELAY_MIN         0.0f
#define VAUDIO_COMPRESSOR_PREDELAY_MAX         4.0f

/*fBXƁ[VGtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_DISTORTION_PARAM
{
    float   fGain;
    float   fEdge;
    float   fPostEQCenterFrequency;
    float   fPostEQBandwidth;
    float   fPreLowpassCutoff;
	
}VAUDIO_DISTORTION_PARAM;

#define VAUDIO_DISTORTION_GAIN_MIN                     -60.0f
#define VAUDIO_DISTORTION_GAIN_MAX                     0.0f
#define VAUDIO_DISTORTION_EDGE_MIN                     0.0f
#define VAUDIO_DISTORTION_EDGE_MAX                     100.0f
#define VAUDIO_DISTORTION_POSTEQCENTERFREQUENCY_MIN    100.0f
#define VAUDIO_DISTORTION_POSTEQCENTERFREQUENCY_MAX    8000.0f
#define VAUDIO_DISTORTION_POSTEQBANDWIDTH_MIN          100.0f
#define VAUDIO_DISTORTION_POSTEQBANDWIDTH_MAX          8000.0f
#define VAUDIO_DISTORTION_PRELOWPASSCUTOFF_MIN         100.0f
#define VAUDIO_DISTORTION_PRELOWPASSCUTOFF_MAX         8000.0f

/*GR[GtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_ECHO_PARAM
{
    float   fWetDryMix;
    float   fFeedback;
    float   fLeftDelay;
    float   fRightDelay;
    long    lPanDelay;
	
}VAUDIO_ECHO_PARAM;

#define VAUDIO_ECHO_WETDRYMIX_MIN      0.0f
#define VAUDIO_ECHO_WETDRYMIX_MAX      100.0f
#define VAUDIO_ECHO_FEEDBACK_MIN       0.0f
#define VAUDIO_ECHO_FEEDBACK_MAX       100.0f
#define VAUDIO_ECHO_LEFTDELAY_MIN      1.0f
#define VAUDIO_ECHO_LEFTDELAY_MAX      2000.0f
#define VAUDIO_ECHO_RIGHTDELAY_MIN     1.0f
#define VAUDIO_ECHO_RIGHTDELAY_MAX     2000.0f
#define VAUDIO_ECHO_PANDELAY_MIN       0
#define VAUDIO_ECHO_PANDELAY_MAX       1

/*tW[GtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_FLANGER_PARAM
{
    float   fWetDryMix;
    float   fDepth;
    float   fFeedback;
    float   fFrequency;
    long    lWaveform;
    float   fDelay;
    long    lPhase;
	
}VAUDIO_FLANGER_PRAM;

#define VAUDIO_FLANGER_WAVE_TRIANGLE       0
#define VAUDIO_FLANGER_WAVE_SIN            1

#define VAUDIO_FLANGER_WETDRYMIX_MIN       0.0f
#define VAUDIO_FLANGER_WETDRYMIX_MAX       100.0f
#define VAUDIO_FLANGER_FREQUENCY_MIN       0.0f
#define VAUDIO_FLANGER_FREQUENCY_MAX       10.0f
#define VAUDIO_FLANGER_DEPTH_MIN           0.0f
#define VAUDIO_FLANGER_DEPTH_MAX           100.0f
#define VAUDIO_FLANGER_PHASE_MIN           0
#define VAUDIO_FLANGER_PHASE_MAX           4
#define VAUDIO_FLANGER_FEEDBACK_MIN        -99.0f
#define VAUDIO_FLANGER_FEEDBACK_MAX        99.0f
#define VAUDIO_FLANGER_DELAY_MIN           0.0f
#define VAUDIO_FLANGER_DELAY_MAX           4.0f

#define VAUDIO_FLANGER_PHASE_NEG_180       0
#define VAUDIO_FLANGER_PHASE_NEG_90        1
#define VAUDIO_FLANGER_PHASE_ZERO          2
#define VAUDIO_FLANGER_PHASE_90            3
#define VAUDIO_FLANGER_PHASE_180           4

/*K[OGtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_GARGLE_PARAM
{
    long	lRateHz;
    long	lWaveShape;
	
}VAUDIO_GARGLE_PARAM;

#define VAUDIO_GARGLE_WAVE_TRIANGLE        0
#define VAUDIO_GARGLE_WAVE_SQUARE          1

#define VAUDIO_GARGLE_RATEHZ_MIN           1
#define VAUDIO_GARGLE_RATEHZ_MAX           1000

/*o[uGtFNg̃p[^ێ\́B*/ 
typedef struct tagVAUDIO_REVERB_PARAM
{
	float   fInGain; 
    float   fReverbMix;
    float   fReverbTime;
    float   fHighFreqRTRatio;

}VAUDIO_REVERB_PARAM;

#define VAUDIO_REVERB_INGAIN_MIN                 -96.0f
#define VAUDIO_REVERB_INGAIN_MAX                 0.0f
#define VAUDIO_REVERB_INGAIN_DEFAULT             0.0f
#define VAUDIO_REVERB_REVERBMIX_MIN              -96.0f
#define VAUDIO_REVERB_REVERBMIX_MAX              0.0f
#define VAUDIO_REVERB_REVERBMIX_DEFAULT          0.0f
#define VAUDIO_REVERB_REVERBTIME_MIN             0.001f
#define VAUDIO_REVERB_REVERBTIME_MAX             3000.0f
#define VAUDIO_REVERB_REVERBTIME_DEFAULT         1000.0f
#define VAUDIO_REVERB_HIGHFREQRTRATIO_MIN        0.001f
#define VAUDIO_REVERB_HIGHFREQRTRATIO_MAX        0.999f
#define VAUDIO_REVERB_HIGHFREQRTRATIO_DEFAULT    0.001f

/*pgbNCRCŨp^ێ\*/
typedef struct tagVAUDIO_PARAMEQ_PARAM 
{
    float fCenter;
    float fBandwidth;
    float fGain;
    
}VAUDIO_PARAMEQ_PARAM;

#define VAUDIO_PARAMEQ_CENTER_MIN      80.0f
#define VAUDIO_PARAMEQ_CENTER_MAX      16000.0f
#define VAUDIO_PARAMEQ_BANDWIDTH_MIN   1.0f
#define VAUDIO_PARAMEQ_BANDWIDTH_MAX   36.0f
#define VAUDIO_PARAMEQ_GAIN_MIN        -15.0f
#define VAUDIO_PARAMEQ_GAIN_MAX        15.0f

/*I3DL2 (Interactive 3D Audio Level 2) o[ũp[^*
*ێ\́B                                           */
typedef struct tagVAUDIO_I3DL2REVERB_PARAM
{
    long   lRoom;                  
    long   lRoomHF;                
    float  flRoomRolloffFactor;  
    float  flDecayTime;           
    float  flDecayHFRatio;        
	long	lReflections;          
    float  flReflectionsDelay;    
    long   lReverb;                
    float  flReverbDelay;         
    float  flDiffusion;            
    float  flDensity;              
    float  flHFReference;         
} VAUDIO_I3DL2REVERB_PARAM;


#define VAUDIO_I3DL2REVERB_ROOM_MIN                   (-10000)
#define VAUDIO_I3DL2REVERB_ROOM_MAX                   0
#define VAUDIO_I3DL2REVERB_ROOM_DEFAULT               (-1000)

#define VAUDIO_I3DL2REVERB_ROOMHF_MIN                 (-10000)
#define VAUDIO_I3DL2REVERB_ROOMHF_MAX                 0
#define VAUDIO_I3DL2REVERB_ROOMHF_DEFAULT             (-100)

#define VAUDIO_I3DL2REVERB_ROOMROLLOFFFACTOR_MIN      0.0f
#define VAUDIO_I3DL2REVERB_ROOMROLLOFFFACTOR_MAX      10.0f
#define VAUDIO_I3DL2REVERB_ROOMROLLOFFFACTOR_DEFAULT  0.0f

#define VAUDIO_I3DL2REVERB_DECAYTIME_MIN              0.1f
#define VAUDIO_I3DL2REVERB_DECAYTIME_MAX              20.0f
#define VAUDIO_I3DL2REVERB_DECAYTIME_DEFAULT          1.49f

#define VAUDIO_I3DL2REVERB_DECAYHFRATIO_MIN           0.1f
#define VAUDIO_I3DL2REVERB_DECAYHFRATIO_MAX           2.0f
#define VAUDIO_I3DL2REVERB_DECAYHFRATIO_DEFAULT       0.83f

#define VAUDIO_I3DL2REVERB_REFLECTIONS_MIN            (-10000)
#define VAUDIO_I3DL2REVERB_REFLECTIONS_MAX            1000
#define VAUDIO_I3DL2REVERB_REFLECTIONS_DEFAULT        (-2602)

#define VAUDIO_I3DL2REVERB_REFLECTIONSDELAY_MIN       0.0f
#define VAUDIO_I3DL2REVERB_REFLECTIONSDELAY_MAX       0.3f
#define VAUDIO_I3DL2REVERB_REFLECTIONSDELAY_DEFAULT   0.007f

#define VAUDIO_I3DL2REVERB_REVERB_MIN                 (-10000)
#define VAUDIO_I3DL2REVERB_REVERB_MAX                 2000
#define VAUDIO_I3DL2REVERB_REVERB_DEFAULT             (200)

#define VAUDIO_I3DL2REVERB_REVERBDELAY_MIN            0.0f
#define VAUDIO_I3DL2REVERB_REVERBDELAY_MAX            0.1f
#define VAUDIO_I3DL2REVERB_REVERBDELAY_DEFAULT        0.011f

#define VAUDIO_I3DL2REVERB_DIFFUSION_MIN              0.0f
#define VAUDIO_I3DL2REVERB_DIFFUSION_MAX              100.0f
#define VAUDIO_I3DL2REVERB_DIFFUSION_DEFAULT          100.0f

#define VAUDIO_I3DL2REVERB_DENSITY_MIN                0.0f
#define VAUDIO_I3DL2REVERB_DENSITY_MAX                100.0f
#define VAUDIO_I3DL2REVERB_DENSITY_DEFAULT            100.0f

#define VAUDIO_I3DL2REVERB_HFREFERENCE_MIN            20.0f
#define VAUDIO_I3DL2REVERB_HFREFERENCE_MAX            20000.0f
#define VAUDIO_I3DL2REVERB_HFREFERENCE_DEFAULT        5000.0f

#define VAUDIO_I3DL2REVERB_QUALITY_MIN                0
#define VAUDIO_I3DL2REVERB_QUALITY_MAX                3
#define VAUDIO_I3DL2REVERB_QUALITY_DEFAULT            2


// I3DL2 Reverberation Presets Values
//

#define VAUDIO_I3DL2REVERB_PRESET_DEFAULT         -1000, -100, 0.0f, 1.49f, 0.83f, -2602, 0.007f,   200, 0.011f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_GENERIC         -1000, -100, 0.0f, 1.49f, 0.83f, -2602, 0.007f,   200, 0.011f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_PADDEDCELL      -1000,-6000, 0.0f, 0.17f, 0.10f, -1204, 0.001f,   207, 0.002f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_ROOM            -1000, -454, 0.0f, 0.40f, 0.83f, -1646, 0.002f,    53, 0.003f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_BATHROOM        -1000,-1200, 0.0f, 1.49f, 0.54f,  -370, 0.007f,  1030, 0.011f, 100.0f,  60.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_LIVINGROOM      -1000,-6000, 0.0f, 0.50f, 0.10f, -1376, 0.003f, -1104, 0.004f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_STONEROOM       -1000, -300, 0.0f, 2.31f, 0.64f,  -711, 0.012f,    83, 0.017f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_AUDITORIUM      -1000, -476, 0.0f, 4.32f, 0.59f,  -789, 0.020f,  -289, 0.030f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_CONCERTHALL     -1000, -500, 0.0f, 3.92f, 0.70f, -1230, 0.020f,    -2, 0.029f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_CAVE            -1000,    0, 0.0f, 2.91f, 1.30f,  -602, 0.015f,  -302, 0.022f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_ARENA           -1000, -698, 0.0f, 7.24f, 0.33f, -1166, 0.020f,    16, 0.030f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_HANGAR          -1000,-1000, 0.0f,10.05f, 0.23f,  -602, 0.020f,   198, 0.030f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_CARPETEDHALLWAY -1000,-4000, 0.0f, 0.30f, 0.10f, -1831, 0.002f, -1630, 0.030f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_HALLWAY         -1000, -300, 0.0f, 1.49f, 0.59f, -1219, 0.007f,   441, 0.011f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_STONECORRIDOR   -1000, -237, 0.0f, 2.70f, 0.79f, -1214, 0.013f,   395, 0.020f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_ALLEY           -1000, -270, 0.0f, 1.49f, 0.86f, -1204, 0.007f,    -4, 0.011f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_FOREST          -1000,-3300, 0.0f, 1.49f, 0.54f, -2560, 0.162f,  -613, 0.088f,  79.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_CITY            -1000, -800, 0.0f, 1.49f, 0.67f, -2273, 0.007f, -2217, 0.011f,  50.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_MOUNTAINS       -1000,-2500, 0.0f, 1.49f, 0.21f, -2780, 0.300f, -2014, 0.100f,  27.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_QUARRY          -1000,-1000, 0.0f, 1.49f, 0.83f,-10000, 0.061f,   500, 0.025f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_PLAIN           -1000,-2000, 0.0f, 1.49f, 0.50f, -2466, 0.179f, -2514, 0.100f,  21.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_PARKINGLOT      -1000,    0, 0.0f, 1.65f, 1.50f, -1363, 0.008f, -1153, 0.012f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_SEWERPIPE       -1000,-1000, 0.0f, 2.81f, 0.14f,   429, 0.014f,   648, 0.021f,  80.0f,  60.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_UNDERWATER      -1000,-4000, 0.0f, 1.49f, 0.10f,  -449, 0.007f,  1700, 0.011f, 100.0f, 100.0f, 5000.0f

#define VAUDIO_I3DL2REVERB_PRESET_SMALLROOM       -1000, -600, 0.0f, 1.10f, 0.83f,  -400, 0.005f,   500, 0.010f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_MEDIUMROOM      -1000, -600, 0.0f, 1.30f, 0.83f, -1000, 0.010f,  -200, 0.020f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_LARGEROOM       -1000, -600, 0.0f, 1.50f, 0.83f, -1600, 0.020f, -1000, 0.040f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_MEDIUMHALL      -1000, -600, 0.0f, 1.80f, 0.70f, -1300, 0.015f,  -800, 0.030f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_LARGEHALL       -1000, -600, 0.0f, 1.80f, 0.70f, -2000, 0.030f, -1400, 0.060f, 100.0f, 100.0f, 5000.0f
#define VAUDIO_I3DL2REVERB_PRESET_PLATE           -1000, -200, 0.0f, 1.30f, 0.90f,     0, 0.002f,     0, 0.010f, 100.0f,  75.0f, 5000.0f
/*************************************************
*vAudioŎgpł֐񋓂܂@@@  *
*************************************************/
#ifdef __cplusplus
extern "C" {
#endif

/**************************************************************************/
/*vAudiȍ܂B@                                        */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioInit( HWND hWnd );

/**************************************************************************/
/*vAudiȍI܂B											  */
/**************************************************************************/
VAUDIO_API void __cdecl vAudioEnd( void );

/**************************************************************************/
/*vAudioœǂݍ݉\ɂt@C̎ނw肵܂					@*/
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioEnableFileType( int FileType , BOOL Value );

/**************************************************************************/
/*ōĐvvC[̃^Cvݒ肵܂B					@*/
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetPlayerType( int PlayerType );

/**************************************************************************/
/*ōĐvvC[̃^Cv擾܂B					@*/
/**************************************************************************/
VAUDIO_API int __cdecl vAudioGetPlayerType();

/**************************************************************************/
/*I[fBIt@Cǂݍ݃I[fBInhint^ŕԂ܂B     */
/**************************************************************************/
VAUDIO_API int __cdecl vAudioLoad( const char* AudioFileName );

/***************************************************************************/
/*̃I[fBIf[^ǂݍ݃I[fBInhint^ŕԂ܂B*/
/***************************************************************************/
VAUDIO_API int __cdecl vAudioLoadFromMemory( void* Memory , unsigned MemorySize );

/**************************************************************************/
/*I[fBInh܂B									  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioRelease( int AudioHandle );

/**************************************************************************/
/*֐vAudioLoad  vAudioLoadFromMemoryŎ擾I[fBInh*/
/*	Sĉ܂B													  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioReleaseAll( void );

/**************************************************************************/
/*Ȃ擪Đ܂B										      */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioPlay( int AudioHandle );

/**************************************************************************/
/*֐vAudioStop AvAudioStopAllŒ~ʒu ́A֐vAudioSeek   */
/*  w肵ʒuĐ܂B(rĐj			                      */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioResume( int AudioHandle );

/**************************************************************************/
/*Đ~܂B													  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioStop( int AudioHandle );

/**************************************************************************/
/*SĂ̍Đ~܂B   											  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioStopAll( void );

/**************************************************************************/
/*Đʒu~bPʂŐݒ肵܂B           					  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSeek( int AudioHandle , unsigned Time );

/**************************************************************************/
/*݂̍Đʒu~bPʂŎ擾܂B							  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetCurrentTime( int AudioHandle , unsigned *pTime );

/**************************************************************************/
/*ȑŜ̒~bPʂŎ擾܂B  				              */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetTotalTime( int AudioHandle , unsigned *pTotalTime );

/**************************************************************************/
/*ĐȂTRUEAłȂFALSEԂ܂B   					  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioIsPlaying( int AudioHandle );

/***********************************************************************************************/
/*[v|Cgݒ肵܂B                  					                           */
/***********************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetLoopPoints( int AudioHandle , unsigned Begin , unsigned End );

/***************************************************************************************************/
/*[v|Cg擾܂B                                         					       */
/***************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetLoopPoints( int AudioHandle , unsigned* pBegin , unsigned* pEnd );

/**************************************************************************/
/*JԂĐ邩ǂݒ肵܂B							  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetRepeat( int AudioHandle , BOOL Repeat );

/**************************************************************************/
/*JԂĐ̐ݒԂ擾܂B@@							  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetRepeat( int AudioHandle , BOOL* pRepeat );

/**************************************************************************/
/*{[ݒ肵܂B											  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetVolume( int AudioHandle , double Volume );

/**************************************************************************/
/*{[擾܂B											  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetVolume( int AudioHandle , double* pVolume );

/**************************************************************************/
/*pݒ肵܂B												      */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetPan( int AudioHandle , double Pan );

/**************************************************************************/
/*p擾܂B													  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetPan( int AudioHandle , double* pPan );

/**************************************************************************/
/*GtFNgݒ肵܂B											  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetEffect( int AudioHandle , unsigned EffectFlag );


/***************************************************************************************************/
/*GtFNg̃p[^[ݒ肵܂B											               */
/***************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetEffectParam( int AudioHandle , unsigned EffectType , void* pParam );

/****************************************************************************************************/
/*GtFNg̃p[^[擾܂B											                */
/****************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetEffectParam( int AudioHandle , unsigned EffectType , void* pParam );
/****************************************************************************************************/
/*vAudioSetEffect()Őݒ肳pgbNCRCU[ݒ肷B			                */
/****************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetParamEqNum( int AudioHandle , unsigned ParamEqNum );
/****************************************************************************************************/
/*vAudioSetEffect()Őݒ肳pgbNCRCU[擾B@@		                */
/****************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetParamEqNum( int AudioHandle , unsigned* pParamEqNum );
/****************************************************************************************************/
/*w肳ꂽCfbNX̃pgbNCRCU[̃p[^ݒ肷B@	                */
/****************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioSetParamEqParam( int AudioHandle , unsigned Index , VAUDIO_PARAMEQ_PARAM* pParamEq );
/****************************************************************************************************/
/*w肳ꂽCfbNX̃pgbNCRCU[̃p[^擾B		                */
/****************************************************************************************************/
VAUDIO_API BOOL __cdecl vAudioGetParamEqParam( int AudioHandle , unsigned Index , VAUDIO_PARAMEQ_PARAM* pParamEq );

/**************************************************************************/
/*Ȃ̐擪tF[hC܂B									  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioFadeIn( int AudioHandle , unsigned FadeTime );

/**************************************************************************/
/*֐vAudioStopAvAudioStopAllŒ~ʒu ́A֐vAudioSeek    */
/*  w肵ʒutF[hC܂B            					  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioResumeFadeIn( int AudioHandle , unsigned FadeTime );

/**************************************************************************/
/*tF[hAEg܂B												  */
/**************************************************************************/
VAUDIO_API BOOL __cdecl vAudioFadeOut( int AudioHandle , unsigned FadeTime );

/**************************************************************************/
/*Ō̃G[擾B									  */
/**************************************************************************/
VAUDIO_API int __cdecl vAudioGetLastError( void );

//=======================================================================================================
//==========================<Rc֐>===================================================================
#define VAUDIO3D_MODE_NORMAL             0x00000000
#define VAUDIO3D_MODE_HEADRELATIVE       0x00000001
#define VAUDIO3D_MODE_DISABLE            0x00000002

#define VAUDIO3D_MINDISTANCEFACTOR      1.175494351e-38F
#define VAUDIO3D_MAXDISTANCEFACTOR      3.402823466e+38F
#define VAUDIO3D_DEFAULTDISTANCEFACTOR  1.0f

#define VAUDIO3D_MINROLLOFFFACTOR       0.0f
#define VAUDIO3D_MAXROLLOFFFACTOR       10.0f
#define VAUDIO3D_DEFAULTROLLOFFFACTOR   1.0f

#define VAUDIO3D_MINDOPPLERFACTOR       0.0f
#define VAUDIO3D_MAXDOPPLERFACTOR       10.0f
#define VAUDIO3D_DEFAULTDOPPLERFACTOR   1.0f

#define VAUDIO3D_DEFAULTMINDISTANCE     1.0f
#define VAUDIO3D_DEFAULTMAXDISTANCE     1000000000.0f

#define VAUDIO3D_MINCONEANGLE           0
#define VAUDIO3D_MAXCONEANGLE           360
#define VAUDIO3D_DEFAULTCONEANGLE       360

#define VAUDIO3D_CALCMODE_IMMEDIATE 0
#define VAUDIO3D_CALCMODE_DEFERRED  1
/*********************************************************************************/
/*3D ver:I[fBIt@Cǂݍ݃I[fBInhint^ŕԂ܂B     */
/*********************************************************************************/
VAUDIO_API int __cdecl vAudio3DLoad( const char* AudioFIleName );

/**********************************************************************************/
/*3D ver:̃I[fBIf[^ǂݍ݃I[fBInhint^ŕԂ܂B*/
/**********************************************************************************/
VAUDIO_API int __cdecl vAudio3DLoadFromMemory( void* Memory , unsigned MemorySIze );

VAUDIO_API BOOL __cdecl vAudio3DSetCalcMode( unsigned Mode );

VAUDIO_API BOOL __cdecl vAudio3DGetCalcMode( unsigned* pMode );

VAUDIO_API BOOL __cdecl vAudio3DCommitSettings();

VAUDIO_API BOOL __cdecl vAudio3DSetMode( int AudioHandle , unsigned Mode );

VAUDIO_API BOOL __cdecl vAudio3DGetMode( int AudioHandle , unsigned* pMode );

VAUDIO_API BOOL __cdecl vAudio3DSetPosition( int AudioHandle , double X , double Y , double Z );

VAUDIO_API BOOL __cdecl vAudio3DGetPosition( int AudioHandle , double* pX , double* pY , double* pZ );

VAUDIO_API BOOL __cdecl vAudio3DSetVelocity( int AudioHandle , double X , double Y , double Z );

VAUDIO_API BOOL __cdecl vAudio3DGetVelocity( int AudioHandle , double* pX , double* pY , double* pZ );

VAUDIO_API BOOL __cdecl vAudio3DSetListenerPosition( double X , double Y , double Z );

VAUDIO_API BOOL __cdecl vAudio3DGetListenerPosition(  double* pX , double* pY , double* pZ );

VAUDIO_API BOOL __cdecl vAudio3DSetListenerVelocity(  double X , double Y , double Z );

VAUDIO_API BOOL __cdecl vAudio3DGetListenerVelocity( double* pX , double* pY , double* pZ );

VAUDIO_API BOOL __cdecl vAudio3DSetListenerOrientation( double FX , double FY , double FZ , double TX , double TY , double TZ );

VAUDIO_API BOOL __cdecl vAudio3DGetListenerOrientation( double* pFX , double* pFY ,double* pFZ ,double* pTX ,double* pTY , double* pTZ );

VAUDIO_API BOOL __cdecl vAudio3DSetDopplerFactor( double Factor );

VAUDIO_API BOOL __cdecl vAudio3DGetDopplerFactor( double* pFactor );

VAUDIO_API BOOL __cdecl vAudio3DSetRolloffFactor( double Factor );

VAUDIO_API BOOL __cdecl vAudio3DGetRolloffFactor( double* pFactor );

VAUDIO_API BOOL __cdecl vAudio3DSetDistanceFactor( double Factor );

VAUDIO_API BOOL __cdecl vAudio3DGetDistanceFactor( double* pFactor );

VAUDIO_API BOOL __cdecl vAudio3DSetMinDistance( int AudioHandle , double Distance );

VAUDIO_API BOOL __cdecl vAudio3DGetMinDistance( int AudioHandle , double* pDistance );

VAUDIO_API BOOL __cdecl vAudio3DSetMaxDistance( int AudioHandle , double Distance );

VAUDIO_API BOOL __cdecl vAudio3DGetMaxDistance( int AudioHandle , double* pDistance );

VAUDIO_API BOOL __cdecl vAudio3DSetConeAngles( int AudioHandle , unsigned InsideAngle , unsigned OutsideAngle );

VAUDIO_API BOOL __cdecl vAudio3DGetConeAngles( int AudioHandle , unsigned* pInsideAngle , unsigned* pOutsideAngle );

VAUDIO_API BOOL __cdecl vAudio3DSetConeOrientation( int AudioHandle , double X , double Y , double Z );

VAUDIO_API BOOL __cdecl vAudio3DGetConeOrientation( int AudioHandle , double* pX , double* pY , double* pZ );

VAUDIO_API BOOL __cdecl vAudio3DSetConeOutsideVolume( int AudioHandle , double Volume );

VAUDIO_API BOOL __cdecl vAudio3DGetConeOutsideVolume( int AudioHandle , double* pVolume );
/***************************************************************************/
/* IvAudio.dllɃNꍇɎgp֐|C^̌^`܂B*/
/***************************************************************************/

typedef BOOL ( __cdecl *VAUDIOINIT )( HWND );
typedef void ( __cdecl *VAUDIOEND )( void );
typedef BOOL ( __cdecl *VAUDIOENABLEFILETYPE)( unsigned , BOOL );
typedef BOOL ( __cdecl *VAUDIOSETPLAYERTYPE)( int );
typedef int  ( __cdecl *VAUDIOGETPLAYERTYPE)();
typedef int  ( __cdecl *VAUDIOLOAD )( const char* );
typedef int  ( __cdecl *VAUDIOLOADFROMMEMORY )( void* , unsigned );
typedef BOOL ( __cdecl *VAUDIORELEASE )( int );
typedef BOOL ( __cdecl *VAUDIORELEASEALL )( void );
typedef BOOL ( __cdecl *VAUDIOPLAY )( int );
typedef BOOL ( __cdecl *VAUDIORESUME )( int );
typedef BOOL ( __cdecl *VAUDIOSTOP )( int );
typedef BOOL ( __cdecl *VAUDIOSTOPALL )( void );
typedef BOOL ( __cdecl *VAUDIOSEEK )( int , unsigned );
typedef BOOL ( __cdecl *VAUDIOGETCURRENTTIME )( int , unsigned* );
typedef BOOL ( __cdecl *VAUDIOGETTOTALTIME )( int , unsigned* );
typedef BOOL ( __cdecl *VAUDIOISPLAYING )( int );
typedef BOOL ( __cdecl *VAUDIOSETLOOPPOINTS)( int , unsigned , unsigned );
typedef BOOL ( __cdecl *VAUDIOGETLOOPPOINTS)( int , unsigned* , unsigned* );
typedef BOOL ( __cdecl *VAUDIOSETREPEAT )( int , BOOL );
typedef BOOL ( __cdecl *VAUDIOGETREPEAT )( int , BOOL* );
typedef BOOL ( __cdecl *VAUDIOSETVOLUME )( int , double );
typedef BOOL ( __cdecl *VAUDIOGETVOLUME )( int , double* );
typedef BOOL ( __cdecl *VAUDIOSETPAN )( int , double );
typedef BOOL ( __cdecl *VAUDIOGETPAN )( int , double* );
typedef BOOL ( __cdecl *VAUDIOSETEFFECT )( int , unsigned );
typedef BOOL ( __cdecl *VAUDIOSETEFFECTPARAM)( int , unsigned , void* );
typedef BOOL ( __cdecl *VAUDIOGETEFFECTPARAM)( int , unsigned , void* );
typedef BOOL ( __cdecl *VAUDIOSETPARAMEQNUM)( int , unsigned );
typedef BOOL ( __cdecl *VAUDIOGETPARAMEQNUM)( int , unsigned* );
typedef BOOL ( __cdecl *VAUDIOSETPARAMEQPARAM)( int , unsigned , VAUDIO_PARAMEQ_PARAM*);
typedef BOOL ( __cdecl *VAUDIOGETPARAMEQPARAM)( int , unsigned , VAUDIO_PARAMEQ_PARAM*);
typedef BOOL ( __cdecl *VAUDIOFADEIN )( int , unsigned );
typedef BOOL ( __cdecl *VAUDIORESUMEFADEIN )( int , unsigned );
typedef BOOL ( __cdecl *VAUDIOFADEOUT )( int , unsigned );
typedef int	 ( __cdecl *VAUDIOGETLASTERROR)( void );
//=======================3D֐Q====================================================
typedef int  ( __cdecl *VAUDIO3DLOAD)( const char* );
typedef int  ( __cdecl *VAUDIO3DLOADFROMMEMORY)( void* ,unsigned );
typedef BOOL ( __cdecl *VAUDIO3DSETCALCMODE)( unsigned  );
typedef BOOL ( __cdecl *VAUDIO3DGETCALCMODE)( unsigned* );
typedef BOOL ( __cdecl *VAUDIO3DCOMMITSETTINGS)();
typedef BOOL ( __cdecl *VAUDIO3DSETMODE)( int , unsigned );
typedef BOOL ( __cdecl *VAUDIO3DGETMODE)( int , unsigned* );
typedef BOOL ( __cdecl *VAUDIO3DSETPOSITION)( int , double , double , double );
typedef BOOL ( __cdecl *VAUDIO3DGETPOSITION)( int , double* , double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETVELOCITY)( int , double , double , double );
typedef BOOL ( __cdecl *VAUDIO3DGETVELOCITY)( int , double* , double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETLISTENERPOSITION)( double ,double ,double );
typedef BOOL ( __cdecl *VAUDIO3DGETLISTENERPOSITION)( double* , double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETLISTENERVELOCITY)( double , double , double );
typedef BOOL ( __cdecl *VAUDIO3DGETLISTENERVELOCITY)( double* ,double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETLISTENERORIENTATION)( double , double ,double , double , double , double );
typedef BOOL ( __cdecl *VAUDIO3DGETLISTENERORIENTATION)( double* , double* , double* , double* , double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETDOPPLERFACTOR)( double );
typedef BOOL ( __cdecl *VAUDIO3DGETDOPPLERFACTOR)( double* );
typedef BOOL ( __cdecl *VAUDIO3DSETROLLOFFFACTOR)( double );
typedef BOOL ( __cdecl *VAUDIO3DGETROLLOFFFACTOR)( double* );
typedef BOOL ( __cdecl *VAUDIO3DSETDISTANCEFACTOR)( double );
typedef BOOL ( __cdecl *VAUDIO3DGETDISTANCEFACTOR)( double* );
typedef BOOL ( __cdecl *VAUDIO3DSETMINDISTANCE)( int , double );
typedef BOOL ( __cdecl *VAUDIO3DGETMINDISTANCE)( int , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETMAXDISTANCE)( int , double );
typedef BOOL ( __cdecl *VAUDIO3DGETMAXDISTANCE)( int , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETCONEANGLES)( int , unsigned , unsigned );
typedef BOOL ( __cdecl *VAUDIO3DGETCONEANGLES)( int , unsigned* , unsigned* );
typedef BOOL ( __cdecl *VAUDIO3DSETCONEORIENTATION)( int , double , double , double );
typedef BOOL ( __cdecl *VAUDIO3DGETCONEORIENTATION)( int , double* , double* , double* );
typedef BOOL ( __cdecl *VAUDIO3DSETCONEOUTSIDEVOLUME)( int , double );
typedef BOOL ( __cdecl *VAUDIO3DGETCONEOUTSIDEVOLUME)( int , double* );

#ifdef __cplusplus
}
#endif

#endif /* INCLUDE_VAUDIO_H */
